#!/bin/bash

# Fix paths from dylibs in MacOSX so that they're loaded from the app bundle
# instead of /usr/local

# <file to fix>

if test "$NEWTARGETPATH" = ""; then
NEWTARGETPATH="@executable_path/../Frameworks"
fi

for file in $*; do

  if [ -f $file ]; then
    new_targetid=$NEWTARGETPATH/$(basename $file)

    # change the id of the library if its a dylib
    if echo $new_targetid|grep dylib; then
      # and not already a relative path
      if ! otool -DX $file|grep @; then
        install_name_tool -id $new_targetid $file
        install_name_tool -change $(otool -DX $file) $new_targetid $file
      fi
    fi

    for lib in $(otool -L $file|grep /usr/local|grep .dylib|cut -f2|cut -f1 -d\  ); do
	new_id=$NEWTARGETPATH/$(basename $lib)
	install_name_tool -change $lib $new_id $file
    done
  fi

done
